// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package journalupdate

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// JournalUpdateClient is the client API for JournalUpdate service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type JournalUpdateClient interface {
	AddEntry(ctx context.Context, in *AddEntryRequest, opts ...grpc.CallOption) (*AddEntryReply, error)
}

type journalUpdateClient struct {
	cc grpc.ClientConnInterface
}

func NewJournalUpdateClient(cc grpc.ClientConnInterface) JournalUpdateClient {
	return &journalUpdateClient{cc}
}

func (c *journalUpdateClient) AddEntry(ctx context.Context, in *AddEntryRequest, opts ...grpc.CallOption) (*AddEntryReply, error) {
	out := new(AddEntryReply)
	err := c.cc.Invoke(ctx, "/journalupdate.JournalUpdate/AddEntry", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// JournalUpdateServer is the server API for JournalUpdate service.
// All implementations must embed UnimplementedJournalUpdateServer
// for forward compatibility
type JournalUpdateServer interface {
	AddEntry(context.Context, *AddEntryRequest) (*AddEntryReply, error)
	mustEmbedUnimplementedJournalUpdateServer()
}

// UnimplementedJournalUpdateServer must be embedded to have forward compatible implementations.
type UnimplementedJournalUpdateServer struct {
}

func (UnimplementedJournalUpdateServer) AddEntry(context.Context, *AddEntryRequest) (*AddEntryReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method AddEntry not implemented")
}
func (UnimplementedJournalUpdateServer) mustEmbedUnimplementedJournalUpdateServer() {}

// UnsafeJournalUpdateServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to JournalUpdateServer will
// result in compilation errors.
type UnsafeJournalUpdateServer interface {
	mustEmbedUnimplementedJournalUpdateServer()
}

func RegisterJournalUpdateServer(s grpc.ServiceRegistrar, srv JournalUpdateServer) {
	s.RegisterService(&JournalUpdate_ServiceDesc, srv)
}

func _JournalUpdate_AddEntry_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AddEntryRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(JournalUpdateServer).AddEntry(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/journalupdate.JournalUpdate/AddEntry",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(JournalUpdateServer).AddEntry(ctx, req.(*AddEntryRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// JournalUpdate_ServiceDesc is the grpc.ServiceDesc for JournalUpdate service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var JournalUpdate_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "journalupdate.JournalUpdate",
	HandlerType: (*JournalUpdateServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "AddEntry",
			Handler:    _JournalUpdate_AddEntry_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "journal-update-api/journalupdate/journal-update.proto",
}
